from django.shortcuts import render
import pyrebase
import logging
from django.contrib import auth
from rest_framework.views import APIView
from rest_framework.response import Response
from rest_framework.permissions import IsAuthenticated
from rest_framework.response import Response


config={
    "apiKey": "AIzaSyAz4vrhTpD4_nTDgiAHRSdz6MPbSg6xZz8",
    "authDomain": "calc-747e4.firebaseapp.com",
    "databaseURL": "https://calc-747e4-default-rtdb.firebaseio.com/",
    "projectId": "calc-747e4",
    "storageBucket": "calc-747e4.appspot.com",
    "messagingSenderId": "1052239053370",
    "appId": "1:1052239053370:web:5d949df4c90064193aab03",
}

firebase=pyrebase.initialize_app(config)
authe = firebase.auth()
database=firebase.database()

#=#=#=#===================#=#=#=#
# database insertion of users #
#=#=#=#===================#=#=#=#

# insert data
# data = {"name": "abc", "email": "", "password": "", "age": 22, "address": ["michigan", "ireland"] }
# data1 = {"name": "cde", "email": "", "password": "", "age": 25, "address": ["michigan", "sri lanka"] }
# database.child("users").push(data)
# database.child("users").push(data1)




# update
# database.child("users").child("-MbAvKho6omXK9qEDPzZ").update({"name": "husmi"})


#=#=#=#===================#=#=#=#
# sign in users #
#=#=#=#===================#=#=#=#



def signIn(request):
    return render(request, "signin.html")


def postsign(request):
    email = request.POST.get('email')
    password = request.POST.get('password')

    try:

        user = authe.sign_in_with_email_and_password(email, password)

        print("logged in")
        print(user)
        session_id=user['localId']
        tokenId = user['idToken']
        print(session_id)
        request.session['uid'] = str(session_id)
        request.session['tokenId'] = str(tokenId)
        print(request.session['uid'])
        return render(request, "home.html")


    except:
        
        print("logged in fail")
        return render(request, "signin.html")

def logout(request):
    auth.logout(request)
    return render(request, "signin.html")


#=#=#=#===================#=#=#=#
# sign up users #
#=#=#=#===================#=#=#=#


def signUp(request):
    return render(request, "signup.html")


def postsignUp(request):
    name = request.POST.get('name'),
    email = request.POST.get('email')
    password = request.POST.get('password')

    
    user = authe.create_user_with_email_and_password(email, password)

    print(user)

    uid = user['localId']

    

    data = {"name": name, "email": email, "password": password}

    database.child("users").child(uid).child("details").set(data)

    # return Response(data={"details": b})

    return render(request, "signin.html")


#=#=#=#===================#=#=#=#
# Add details #
#=#=#=#===================#=#=#=#

def details(request):
    return render(request, "details.html")




def postcropcreate(request):

    earns = request.POST.get('earns')
    points = request.POST.get('points')

    data = {
        "earns": earns,
        "points": points
    }

    tokenId = request.session['tokenId']
   


    a = authe.get_account_info(tokenId)
    a = a['users']
    a = a[0]
    a = a['localId']
   

    database.child("users").child(a).child("details").child("points").set(data)

    # send name to FE
    # name = database.child("users").child(a).child("details").child("name").get().val()
    # return render(request, "home.html", {"e": name})

    return render(request, "home.html")

#=#=#=#===================#=#=#=#
# Retrieve data #
#=#=#=#===================#=#=#=#

def check(request): 
    tokenId = request.session['tokenId']
    print(tokenId)
    a = authe.get_account_info(tokenId)

    a = a['users']
    a = a[0]
    a = a['localId']

    print(a)

    
    userDetails = database.child("users").child(a).child("details").get().val()
  
    lis_time=[]

    det = userDetails.values()

    for i in det:
        lis_time.append(i)
 

    print(lis_time) 

    pointsval = lis_time[3]

    pointVals = pointsval.values()

    points_arr=[]

    for i in pointVals:
        points_arr.append(i)

    print(points_arr)

   

    return render(request, "showDetails.html")


#=#=#=#===================#=#=#=#
# Delete User #
#=#=#=#===================#=#=#=#    

def removeUser(request):
    tokenId = request.session['tokenId']
    print(tokenId)
    a = authe.get_account_info(tokenId)

    a = a['users']
    a = a[0]
    a = a['localId']

    userDetails = database.child("users").child(a).remove()

    print(userDetails)

    return render(request, "home.html")



#=#=#=#===================#=#=#=#
# Update User #
#=#=#=#===================#=#=#=#  

def updateUser(request): 

    return render(request, 'updateDetails.html')

def post_updated(request):

    tokenId = request.session['tokenId']
    print(tokenId)
    a = authe.get_account_info(tokenId)

    a = a['users']
    a = a[0]
    a = a['localId']

    name = request.POST.get('name'),
    email = request.POST.get('email')

    userDetails = database.child("users").child(a).child("details").update({"name": name, "email": email})

    print(userDetails)

    return render(request, "home.html")



# Create your views here.
